import "package:test/test.dart";

import "../lib/youtube_parser.dart";

void main() {

  test("Should work", () {
    List<String> links = [
      "https://www.youtube.com/watch?v=CBWlfU_na-2",
      "https://www.youtube.com/watch?v=CBWlfU_na-2?t=27m53s",
      "https://www.youtube.com/watch?v=CBWlfU_na-2&list=xS9cRDfFtF9FM#t=0",
      "https://m.youtube.com/watch?v=CBWlfU_na-2",
      "https://m.youtube.com/watch?v=CBWlfU_na-2&list=xS9cRDfFtF9FM#t=0",
      "https://youtu.be/CBWlfU_na-2",
      "https://youtu.be/CBWlfU_na-2?list=RDtF9FxSfF9cM"
    ];

    for(String link in links)
      expect(getIdFromUrl(link), equals("CBWlfU_na-2"));
  });

  test("Should fail", () {
    List<String> links = [
      null,
      "",
      "https://www.any-website.com",
      "https://www.notyoutube.com/watch?v=CBWlfU_na-2",
      "https://www.youtube.com/watch?v=CBWlfU_na-",
      "https://n.youtube.com/watch?v=CBWlfU_na-2",
      "https://m.youtube.com/wtch?v=CBWlfU_na-2&list=xS9cRDfFtF9FM#t=0",
      "https://youtu.be/CBWlfU_na-",
      "https://youtu.de/CBWlfU_na-2",
      "https://www.youtu.be/CBWlfU_na-2"
    ];

    for(String link in links)
      expect(getIdFromUrl(link), isNull);
  });
}
